<?php

//
// phpBB hook_urlname
//
define('HOOK_URLNAME_VERSION','0.0.9-20140312');
//
// copyright (c) 2014 c61 http://c61.no-ip.org <c61@yandex.ru>
// license http://opensource.org/licenses/gpl-license.php GNU Public License
//

if (!defined('IN_PHPBB'))
{
	exit;
}

function urlname()
{
	global $template;

	if(isset($template->_tpldata['postrow']))
	{
		// Применяем функцию do_urlname() к каждому члену массива postrow, содержащего тексты сообщений
		foreach($template->_tpldata['postrow'] as $key => $val)
		{
			do_urlname($template->_tpldata['postrow'][$key]['MESSAGE']);
		}
	} elseif (isset($template->_rootref))
	{
		// Применяем функцию do_urlname() к предпросмотру сообщения
		do_urlname($template->_rootref['PREVIEW_MESSAGE']);
		do_urlname($template->_rootref['MESSAGE']);
		// Возможно, есть обзор сообщений в предпросмотре
		if(isset($template->_tpldata['topic_review_row']))
		{
			foreach($template->_tpldata['topic_review_row'] as $key => $val)
			{
				do_urlname($template->_tpldata['topic_review_row'][$key]['MESSAGE']);
			}
		}
		if(isset($template->_tpldata['history_row']))
		{
			foreach($template->_tpldata['history_row'] as $key => $val)
			{
				do_urlname($template->_tpldata['history_row'][$key]['MESSAGE']);
			}
		}
	}
}

function do_urlname_auth(&$forums, $forum_id, $global = POST_GLOBAL)
{
	global $auth;

	if (!isset($forums[$forum_id]['auth']))
	{
		$forums[$forum_id]['auth'] = $auth->acl_gets('f_list', 'f_read', $forum_id);
	}
	return (($global == POST_GLOBAL) || $forums[$forum_id]['auth']) ? true : false;
}

function do_urlname_not_url($str)
{
	return (strpos($str,'://') === false) ? true : false;
}

function do_urlname_debug($str)
{
	global $template;

	if (isset($template->_rootref['DEBUG_OUTPUT']))
	{
		$template->_rootref['DEBUG_OUTPUT'] .= ' | ' . $str;
	}
}

function do_urlname(&$item)
{
	global $db, $user, $phpEx, $phpbb_seo;

	if(!isset($item)) return;

	//-------------------------------------------------------------------------

	// Настройки мода

	// Форумы, темы, сообщения
	// Использовать всплывающую подсказку (время размещения и номер сообщения) названий тем, сообщений
	$use_iurl_title['use'] = true;
	// Использовать выделение (тэги strong, i) названий форумов, тем, сообщений
	$use_iurl_strong['use'] = true;
	// Открывающй и закрывающий тэги выделения названий форумов, тем, сообщений
	$use_iurl_strong['open'] = $use_iurl_strong['use'] ? '<strong><i>' : '';
	$use_iurl_strong['close'] = $use_iurl_strong['use'] ? '</i></strong>': '';

	// Пользователи
	// Использовать цвет ника пользователя
	$use_user_colour = true;
	// Использовать выделение (тэг strong) ника пользователя
	$use_user_strong['use'] = true;
	// Открывающй и закрывающий тэги выделения ника пользователя
	$use_user_strong['open'] = $use_user_strong['use'] ? '<strong>' : '';
	$use_user_strong['close'] = $use_user_strong['use'] ? '</strong>': '';

	// Ресурсы Wiki
	// Использовать выделение (тэг i) разделов wiki
	$use_wiki_strong['use'] = true;
	// Открывающй и закрывающий тэги выделения разделов wiki
	$use_wiki_strong['open'] = $use_wiki_strong['use'] ? '<i>' : '';
	$use_wiki_strong['close'] = $use_wiki_strong['use'] ? '</i>': '';
	// Поиск URL
	{
		$wiki_search = array(
			'/>http(.*?)\:\/\/(\S+)\.wikipedia\.org\/wiki\/(.*?)</isu',
			'/>http(.*?)\:\/\/(\S+)\.wikiquote\.org\/wiki\/(.*?)</isu',
			'/>http(.*?)\:\/\/(\S+)\.wikibooks\.org\/wiki\/(.*?)</isu',
			'/>http(.*?)\:\/\/(wiki)\.phpbb\.com\/(.*?)</isu',
			'/>http(.*?)\:\/\/(wiki)\.wargaming\.net\/ru\/(.*?)</isu',
			'/>http(.*?)\:\/\/(wiki)\.iteach\.ru\/index\.php\/(.*?)</isu',
			'/>http(.*?)\:\/\/(wiki)\.debian\.org\/(.*?)</isu',
			'/>http(.*?)\:\/\/(wiki)\.web\.ru\/wiki\/(.*?)</isu',
			'/>http(.*?)\:\/\/(www\.)*lurkmore\.to\/(.*?)</isu',
			'/>http(.*?)\:\/\/(www\.)*sportswiki\.ru\/(.*?)</isu',
			'/>http(.*?)\:\/\/(www\.)*altlinux\.org\/(.*?)</isu',
		);
	}

	//-------------------------------------------------------------------------

	// Поиск для стандартных URL
	{
		$std_search = array(
//			вариант без учёта hilit=viewtopic
//			'p'	=>	'/>viewtopic\.'.$phpEx.'(.*?)[\?|&|;]p=(\d+)/isu',
//			't'	=>	'/>viewtopic\.'.$phpEx.'(.*?)[\?|&|;]t=(\d+)/isu',
//			вариант с учётом hilit=viewtopic
			'p'	=>	'/>(<span\s*class=\"posthilit\">|)viewtopic(<\/span>|)\.'.$phpEx.'(.*?)[\?|&|;]p=(\d+)/isu',
			't'	=>	'/>(<span\s*class=\"posthilit\">|)viewtopic(<\/span>|)\.'.$phpEx.'(.*?)[\?|&|;]t=(\d+)/isu',
			'f'	=>	'/>viewforum\.'.$phpEx.'(.*?)[\?|&|;]f=(\d+)/isu',
			'u'	=>	'/>memberlist\.'.$phpEx.'(.*?)[\?|&|;]u=(\d+)/isu',
		);
	}
	// Поиск для Simple SEO mod URL или SEO Ultimate SEO URL в режиме Simple
	{
		$sseo_search = array(
			'p'	=>	'/>post(\d+)(.*?)\.html(.*?)#p(\d+)/isu',
			'pt'	=>	'/>topic(\d+)(.*?)\.html(.*?)#p(\d+)/isu',
			't'	=>	'/>topic(\d+)(.*?)\.html/isu',
			'f'	=>	'/>forum(\d+)\.html/isu',
			'u'	=>	'/>member(\d+)\.html/isu',
		);
	}
	// Поиск для Ultimate SEO mod URL
	if (isset($phpbb_seo))
	{
		$useo_search = array(
			'p'	=>	'/>(.*?)-t(\d+)(.*?)\.html(.*?)#p(\d+)/isu',
			't'	=>	'/>(.*?)-t(\d+)(.*?)\.html/isu',
			'f'	=>	'/>(.*?)\.html/isu',
			'f-f'	=>	'/>(.*?)-f(\d+)\.html/isu',
			'u'	=>	'/>(.*?)-u(\d+)\.html/isu',
		);
	}

	//-------------------------------------------------------------------------

	// Разыскиваемые тэги
	// Будут исключены:
	// pre, code - это код и незачем...
	// script - скрипты тем более не трогаем
	$tags = array('pre','code','script');
	$ent = array();
	foreach($tags as $tag)
	{
		// Поиск тэга
		if(preg_match_all('/(?=(<$tag.*?>(?>(?1)|.)*?<\/$tag>))/isu',$item,$matches,PREG_OFFSET_CAPTURE))
		{
			foreach($matches[1] as $match)
			{
				// Собираем вхождения тэгов в массив 'индекс' => 'длина'
				$ent[(int) $match[1]] = (int) strlen($match[0]);
			}
		}
	}
	// Добавляем пустышку - чтобы алгоритм обработал остатки текста за последним тэгом
	$ent[(int) strlen($item)] = (int) 0;

	// Сортируем по ключу, по возрастанию
	if(ksort($ent))
	{
		// Начальный индекс, новый текст
		$start = 0;
		$newtext = '';
		// Кэш для уменьшения количества sql-запросов
		$posts = array();
		$topics = array();
		$forums = array();
		$users = array();
		// Проход по всем вхождениям
		foreach($ent as $key => $val)
		{
			if($key > $start)	// Индекс больше стартового ?
			{
				// Да. Выделяем подстроку
				$substr = substr($item,$start,$key-$start);

				// Поиски и замены
				if (isset($searches)) unset($searches);
				if (isset($replaces)) unset($replaces);
				$searches = array();
				$replaces = array();

				// Поиск тэга <a...href="..."...>?</a>
				if(preg_match_all('/<a(.*?)href=[\"|\'](.*?)[\"|\'](.*?)>(.*?)<\/a>/isu',$substr,$amatches))
				{
					$i = -1;
					foreach($amatches[4] as $amatch)
					{
						$i++;

						// Подготовка поиска
						if (isset($search)) unset($search);
						if (isset($replace)) unset($replace);
						if (isset($strong)) unset($strong);
						if (isset($title)) unset($title);

						// Проверяем на наличие ссылки в href с учётом hilit
						if (strpos(htmlspecialchars_decode($amatches[2][$i]),str_replace(array('<span class="posthilit">','</span>','./'),'',htmlspecialchars_decode($amatch))) !== false)
						{

							// Поиск вариантов...
							//if (!isset($search))
							{
								// Поиск viewtopic.php?....p=? или аналога SEO
								$post_id = 0;
								if (isset($std_search)
								 && preg_match($std_search['p'],'>'.$amatch,$pmatch)
								// вариант без учёта hilit=viewtopic
								// &&	!empty($pmatch[2])
								// вариант с учётом hilit=viewtopic
								 &&	!empty($pmatch[4])
									)
								{
									// вариант без учёта hilit=viewtopic
									//$post_id = $pmatch[2];
									// вариант с учётом hilit=viewtopic
									$post_id = $pmatch[4];
								}
								else if (isset($sseo_search)
								 &&      preg_match($sseo_search['p'],'>'.$amatch,$pmatch)
								 &&	     !empty($pmatch[4])
									)
								{
									$post_id = $pmatch[4];
								}
								else if (isset($sseo_search)
								 &&      preg_match($sseo_search['pt'],'>'.$amatch,$pmatch)
								 &&	     !empty($pmatch[4])
									)
								{
									$post_id = $pmatch[4];
								}
								else if (isset($useo_search)
								 &&      preg_match($useo_search['p'],'>'.$amatch,$pmatch)
								 &&	     !empty($pmatch[1])
								 &&      do_urlname_not_url($pmatch[1])
								 &&	     !empty($pmatch[2])
								 &&	     !empty($pmatch[5])
									)
								{
									$post_id = $pmatch[5];
								}
								if ($post_id)
								{
									
									if (empty($posts[$post_id]))
									{
										$sql = 'SELECT forum_id,topic_id,post_subject,post_time
											FROM ' . POSTS_TABLE . '
											WHERE post_id = ' . $post_id;
										$result = $db->sql_query($sql);
										$row = $db->sql_fetchrow($result);
										$db->sql_freeresult($result);
										if (empty($row)) continue;

										if (strpos($row['post_subject'],'Re: ') === 0)
										{
											$row['post_subject'] = substr_replace($row['post_subject'],'',0,4);
										}

										$posts[$post_id] = $row;
									}
									$topic_id = $posts[$post_id]['topic_id'];

									if (empty($topics[$topic_id]))
									{
										$sql = 'SELECT topic_type,topic_title,topic_time,topic_first_post_id,topic_first_poster_name
											FROM ' . TOPICS_TABLE . '
											WHERE topic_id = ' . $topic_id;
										$result = $db->sql_query($sql);
										$row = $db->sql_fetchrow($result);
										$db->sql_freeresult($result);

										$topics[$topic_id] = $row;
										$topics[$topic_id]['forum_id'] = $posts[$post_id]['forum_id'];
									}

									if (empty($posts[$post_id]['post_subject']))
									{
										$posts[$post_id]['post_subject'] = $topics[$topic_id]['topic_title'];
									}

									if (do_urlname_auth($forums, $posts[$post_id]['forum_id'], $topics[$topic_id]['topic_type']))
									{
										$strong = $use_iurl_strong;
										$title = $use_iurl_title;
										if ($post_id == $topics[$topic_id]['topic_first_post_id'])
										{
											$title['type'] = 'topic';
											$title['username'] = $topics[$topic_id]['topic_first_poster_name'];
										}
										else
										{
											$title['type'] = 'post';
											$title['id'] = $post_id;
										}
										$title['title'] = $topics[$topic_id]['topic_title'];
										$title['time'] = $posts[$post_id]['post_time'];
										$search = '>'.$amatch.'<';
										$replace = '>'.censor_text($posts[$post_id]['post_subject']).'<';
									}
								}
							}
							if (!isset($search))
							{
								// Поиск viewtopic.php?....t=? или аналога SEO
								$topic_id = 0;
								if (isset($std_search)
								 && preg_match($std_search['t'],'>'.$amatch,$tmatch)
								// вариант без учёта hilit=viewtopic
								// &&	!empty($tmatch[2])
								// вариант с учётом hilit=viewtopic
								 &&	!empty($tmatch[4])
									)
								{
								// вариант без учёта hilit=viewtopic
								//	$topic_id = $tmatch[2];
								// вариант с учётом hilit=viewtopic
									$topic_id = $tmatch[4];
								}
								else if (isset($sseo_search)
								 &&      preg_match($sseo_search['t'],'>'.$amatch,$tmatch)
								 &&	     !empty($tmatch[1])
									)
								{
									$topic_id = $tmatch[1];
								}
								else if (isset($useo_search)
								 &&      preg_match($useo_search['t'],'>'.$amatch,$tmatch)
								 &&	     !empty($tmatch[1])
								 &&      do_urlname_not_url($tmatch[1])
								 &&	     !empty($tmatch[2])
									)
								{
									$topic_id = $tmatch[2];
								}
								if ($topic_id)
								{
									if (empty($topics[$topic_id]))
									{
										$sql = 'SELECT forum_id,topic_type,topic_title,topic_time,topic_first_post_id,topic_first_poster_name
											FROM ' . TOPICS_TABLE . '
											WHERE topic_id = ' . $topic_id;
										$result = $db->sql_query($sql);
										$row = $db->sql_fetchrow($result);
										$db->sql_freeresult($result);
										if (empty($row)) continue;

										$topics[$topic_id] = $row;
									}

									if (do_urlname_auth($forums, $topics[$topic_id]['forum_id'], $topics[$topic_id]['topic_type']))
									{
										$strong = $use_iurl_strong;
										$title = $use_iurl_title;
										$title['type'] = 'topic';
										$title['username'] = $topics[$topic_id]['topic_first_poster_name'];
										$title['title'] = $topics[$topic_id]['topic_title'];
										$title['time'] = $topics[$topic_id]['topic_time'];
										$search = '>'.$amatch.'<';
										$replace = '>'.censor_text($topics[$topic_id]['topic_title']).'<';
									}
								}
							}
							if (!isset($search))
							{
								// Поиск viewforum.php?....f=? или аналога SEO
								$forum_id = 0;
								if (isset($std_search)
								 && preg_match($std_search['f'],'>'.$amatch,$fmatch)
								 &&	!empty($fmatch[2])
									)
								{
									$forum_id = $fmatch[2];
								}
								else if (isset($sseo_search)
								 &&      preg_match($sseo_search['f'],'>'.$amatch,$fmatch)
								 &&	     !empty($fmatch[1])
									)
								{
									$forum_id = $fmatch[1];
								}
								else if (isset($useo_search)
								 &&      preg_match($useo_search['f'],'>'.$amatch,$fmatch)
								 &&	     !empty($fmatch[1])
								 &&      do_urlname_not_url($fmatch[1])
								 &&      ($forum_id = $phpbb_seo->get_forum_id($forum_id,$fmatch[1]))
									)
								{
									;
								}
								else if (isset($useo_search)
								 &&      preg_match($useo_search['f-f'],'>'.$amatch,$fmatch)
								 &&	     !empty($fmatch[1])
								 &&      do_urlname_not_url($fmatch[1])
								 &&	     !empty($fmatch[2])
									)
								{
									$forum_id = $fmatch[2];
								}
								if ($forum_id)
								{
									if (empty($forums[$forum_id]['forum_name']))
									{
										$sql = 'SELECT forum_name,forum_desc
											FROM ' . FORUMS_TABLE . '
											WHERE forum_id = ' . $forum_id;
										$result = $db->sql_query($sql);
										$row = $db->sql_fetchrow($result);
										$db->sql_freeresult($result);
										if (empty($row)) continue;

										$forums[$forum_id]['forum_name'] = $row['forum_name'];
										$forums[$forum_id]['forum_desc'] = $row['forum_desc'];
									}

									if (do_urlname_auth($forums, $forum_id))
									{
										$strong = $use_iurl_strong;
										$title = $use_iurl_title;
										$title['type'] = 'forum';
										$title['title'] = $forums[$forum_id]['forum_name'] . (!empty($forums[$forum_id]['forum_desc']) ? (': '.$forums[$forum_id]['forum_desc']) : '');
										$search = '>'.$amatch.'<';
										$replace = '>'.$forums[$forum_id]['forum_name'].'<';
									}
								}
							}
							if (!isset($search))
							{
								// Поиск memberlist.php?....u=? или аналога SEO
								$user_id = 0;
								if (isset($std_search)
								 && preg_match($std_search['u'],'>'.$amatch,$umatch)
								 &&	!empty($umatch[2])
									)
								{
									$user_id = $umatch[2];
								}
								else if (isset($sseo_search)
								 &&      preg_match($sseo_search['u'],'>'.$amatch,$umatch)
								 &&	     !empty($umatch[1])
									)
								{
									$user_id = $umatch[1];
								}
								else if (isset($useo_search)
								 &&      preg_match($useo_search['u'],'>'.$amatch,$umatch)
								 &&	     !empty($umatch[1])
								 &&      do_urlname_not_url($umatch[1])
								 &&      !empty($umatch[2])
									)
								{
									$user_id = $umatch[2];
								}
								if ($user_id)
								{
									if (empty($users[$user_id]))
									{
										$sql = 'SELECT username,user_colour
											FROM ' . USERS_TABLE . '
											WHERE user_id = ' . $user_id;
										$result = $db->sql_query($sql);
										$row = $db->sql_fetchrow($result);
										$db->sql_freeresult($result);
										if (empty($row)) continue;

										$users[$user_id] = $row;
									}
									if ($user_id == ANONYMOUS)
									{
										$users[$user_id]['username'] = $user->lang['GUEST'];
									}
									if (!empty($users[$user_id]['username']))
									{
										if ($use_user_colour)
										{
											$search = $amatches[0][$i];
											$replace = ($use_user_strong['use'] ? $use_user_strong['open'] : '').get_username_string('full', $user_id, $users[$user_id]['username'], $users[$user_id]['user_colour']).($use_user_strong['use'] ? $use_user_strong['close'] : '');
										}
										else
										{
											$strong = $use_user_strong;
											$search = '>'.$amatch.'<';
											$replace = '>'.$users[$user_id]['username'].'<';
										}
									}
								}
							}
						}

						// Wiki
						if (!isset($search) && isset($wiki_search))
						{
							foreach ($wiki_search as $wiki)
							{
								if (!($dowiki = ((strpos($amatch,'http://') === 0) || (strpos($amatch,'https://') === 0)) && (strpos($amatch,' ... ') !== false)))
								{
									if (preg_match($wiki,'>'.urldecode($amatch).'<',$wmatch))
									{
										$dowiki = !empty($wmatch[3]);
									}
								}
								if ($dowiki)
								{
									if(preg_match($wiki,'>'.urldecode($amatches[2][$i]).'<',$hmatch))
									{
										$wiki_topic = str_replace('_',' ',$hmatch[3]);
										if (($p = strpos($wiki_topic,'#')) !== false)
										{
											$wiki_subtopic = substr($wiki_topic,$p + 1);
											if (preg_match('/\.([0-9A-Z]{2})/i', $wiki_subtopic))
											{
												$wiki_subtopic = str_replace('%','.',urldecode(str_replace('.', '%', $wiki_subtopic)));
											}
											$wiki_topic = substr($wiki_topic,0,$p) . ': ' . $wiki_subtopic;
										}
										$wiki_topic = htmlspecialchars(str_replace(':',': ',$wiki_topic));
										if (!empty($wiki_topic))
										{
											$strong = $use_wiki_strong;
											$search = '>'.$amatch.'<';
											$replace = '>'.$wiki_topic.'<';
										}
										break;
									}
								}
							}
						}
						// Обработка поисков и замен в подстроке
						if (isset($search) && isset($replace))
						{
							if (!in_array($amatches[0][$i],$searches))
							{
								$a_replace = $amatches[0][$i];
								$do_a_replace = false;
								if (isset($title) && $title['use'] && !empty($title['type']))
								{
									if (!preg_match('/title=[\"|\'](.*?)[\"|\']/isu', $a_replace))
									{
										$ar = '<a title="';
										switch ($title['type'])
										{
											case 'post':
												$ar .= $user->lang('MESSAGE').' #'.$title['id'].' &bull; ';
											case 'topic':
												$ar .= $user->lang('TOPIC').' `'.$title['title'].'`';
												break;
											case 'forum':
												$ar .= $user->lang('FORUM').' `'.$title['title'].'`';
												break;
										}
										if (!empty($title['username']))
										{
											$ar .= ' &bull; '.$user->lang('AUTHOR').' '.$title['username'];
										}
										if (!empty($title['time']))
										{
											$ar .= ' &bull; '.$user->lang('POST_TIME').' '.$user->format_date($title['time'], false, false);
										}
										$ar .= '" ';
										$a_replace = str_replace('<a ',$ar,$a_replace);
										$do_a_replace = true;
									}
								}
								if (isset($strong) && $strong['use'] && !in_array($amatches[0][$i],$searches) && !empty($strong['open']) && !empty($strong['close']))
								{
										$a_replace = $strong['open'].$a_replace.$strong['close'];
										$do_a_replace = true;
								}
								if ($do_a_replace)
								{
									$searches[] = $amatches[0][$i];
									$replaces[] = $a_replace;
								}
							}
							if (!in_array($search,$searches))
							{
								$searches[] = $search;
								$replaces[] = $replace;
							}
						}
					}
					$substr = @str_replace($searches, $replaces, $substr);
				}

				// Отправляем подстроку с заменами и тэги в результирующий текст
				$newtext .= $substr . ($val ? substr($item,$key,$val) : '');
				// Переопределяем начальный индекс
				$start = $key + $val;
			}
		}

		// Если всё нормально - переопределяем текст сообщения
		if($newtext != '')
		{
			$item = $newtext;
		}
	}
}

// Регистрируем хук
$phpbb_hook->register(array('template', 'display'), 'urlname');

?>